Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Olympus.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Olympus.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Olympus.pm	(revision 34921)
@@ -333,16 +775,27 @@
         },
     },
-    0x0303 => { #11
-        Name => 'WhiteBalanceBracket',
-        Writable => 'int16u',
-    },
-    0x0304 => { #11
-        Name => 'WhiteBalanceBias',
-        Writable => 'int16u',
-    },
-   # 0x0305 => 'PrintMaching', ? #11
+    0x0303 => { Name => 'WhiteBalanceBracket',  Writable => 'int16u' }, #11
+    0x0304 => { Name => 'WhiteBalanceBias',     Writable => 'int16u' }, #11
+   # 0x0305 => 'PrintMatching', ? #11
+    0x0400 => { #IB
+        Name => 'SensorArea',
+        Condition => '$$self{TIFF_TYPE} eq "ERF"',
+        Writable => 'undef',
+        Format => 'int16u',
+        Count => 4,
+        Notes => 'found in Epson ERF images',
+    },
+    0x0401 => { #IB
+        Name => 'BlackLevel',
+        Condition => '$$self{TIFF_TYPE} eq "ERF"',
+        Writable => 'int32u',
+        Count => 4,
+        Notes => 'found in Epson ERF images',
+    },
+    # 0x0402 - BitCodedAutoFocus (ref 11)
     0x0403 => { #11
         Name => 'SceneMode',
         Writable => 'int16u',
+        PrintConvColumns => 2,
         PrintConv => {
             0 => 'Normal',
@@ -381,16 +834,14 @@
             33 => 'Pet',
             34 => 'Smile Shot',
+            35 => 'Quick Shutter',
+            43 => 'Hand-held Starlight', #PH (SH-21)
+            100 => 'Panorama', #PH (SH-21)
             101 => 'Magic Filter', #PH
-        },
-    },
-    0x0404 => { #PH (D595Z, C7070WZ)
-        Name => 'SerialNumber',
-        Writable => 'string',
-    },
-    0x0405 => { #11
-        Name => 'Firmware',
-        Writable => 'string',
-    },
-    0x0e00 => {
+            103 => 'HDR', #PH (XZ-2)
+        },
+    },
+    0x0404 => { Name => 'SerialNumber', Writable => 'string' }, #PH (D595Z, C7070WZ)
+    0x0405 => { Name => 'Firmware',     Writable => 'string' }, #11
+    0x0e00 => { # (AFFieldCoord for models XZ-2 and XZ-10, ref 11)
         Name => 'PrintIM',
         Description => 'Print Image Matching',
@@ -400,4 +851,5 @@
         },
     },
+    # 0x0e80 - undef[256] - offset 0x30: uint16[2] WB_RGBLevels = val[0]*561,65536,val[1]*431 (ref IB)
     0x0f00 => {
         Name => 'DataDump',
@@ -412,5 +864,5 @@
     0x0f04 => {
         Name => 'ZoomedPreviewStart',
-        # NOTE: this tag is not currently updated properly when the image is rewritten!
+        # NOTE: this tag is currently not updated properly when the image is rewritten!
         OffsetPair => 0xf05,
         DataTag => 'ZoomedPreviewImage',
@@ -484,16 +936,7 @@
         Writable => 'rational64s',
     },
-    0x1007 => { #6 (E-10, E-20 and C2500L - numbers usually around 30-40)
-        Name => 'SensorTemperature',
-        Writable => 'int16s',
-    },
-    0x1008 => { #6
-        Name => 'LensTemperature',
-        Writable => 'int16s',
-    },
-    0x1009 => { #11
-        Name => 'LightCondition',
-        Writable => 'int16u',
-    },
+    0x1007 => { Name => 'SensorTemperature',Writable => 'int16s' }, #6 (E-10, E-20 and C2500L - numbers usually around 30-40)
+    0x1008 => { Name => 'LensTemperature',  Writable => 'int16s' }, #6
+    0x1009 => { Name => 'LightCondition',   Writable => 'int16u' }, #11
     0x100a => { #11
         Name => 'FocusRange',
@@ -518,12 +961,6 @@
         PrintConvInv => '$val=~s/\s*mm$//; $val',
     },
-    0x100d => { #6
-        Name => 'ZoomStepCount',
-        Writable => 'int16u',
-    },
-    0x100e => { #6
-        Name => 'FocusStepCount',
-        Writable => 'int16u',
-    },
+    0x100d => { Name => 'ZoomStepCount',    Writable => 'int16u' }, #6
+    0x100e => { Name => 'FocusStepCount',   Writable => 'int16u' }, #6
     0x100f => { #6
         Name => 'Sharpness',
@@ -536,8 +973,5 @@
         },
     },
-    0x1010 => { #6
-        Name => 'FlashChargeLevel',
-        Writable => 'int16u',
-    },
+    0x1010 => { Name => 'FlashChargeLevel', Writable => 'int16u' }, #6
     0x1011 => { #3
         Name => 'ColorMatrix',
@@ -546,9 +980,5 @@
         Count => 9,
     },
-    0x1012 => { #3
-        Name => 'BlackLevel',
-        Writable => 'int16u',
-        Count => 4,
-    },
+    0x1012 => { Name => 'BlackLevel',       Writable => 'int16u', Count => 4 }, #3
     0x1013 => { #11
         Name => 'ColorTemperatureBG',
@@ -565,4 +995,5 @@
         Writable => 'int16u',
         Count => 2,
+        PrintConvColumns => 2,
         PrintConv => {
             '1'   => 'Auto',
@@ -594,13 +1025,7 @@
         ValueConvInv => '$val*=256;"$val 64"',
     },
-    0x1019 => { #11
-        Name => 'ColorMatrixNumber',
-        Writable => 'int16u',
-    },
+    0x1019 => { Name => 'ColorMatrixNumber',    Writable => 'int16u' }, #11
     # 0x101a is same as CameraID ("OLYMPUS DIGITAL CAMERA") for C2500L - PH
-    0x101a => { #3
-        Name => 'SerialNumber',
-        Writable => 'string',
-    },
+    0x101a => { Name => 'SerialNumber',         Writable => 'string' }, #3
     0x101b => { #11
         Name => 'ExternalFlashAE1_0',
@@ -608,51 +1033,14 @@
         Unknown => 1, # (what are these?)
     },
-    0x101c => { #11
-        Name => 'ExternalFlashAE2_0',
-        Writable => 'int32u',
-        Unknown => 1,
-    },
-    0x101d => { #11
-        Name => 'InternalFlashAE1_0',
-        Writable => 'int32u',
-        Unknown => 1,
-    },
-    0x101e => { #11
-        Name => 'InternalFlashAE2_0',
-        Writable => 'int32u',
-        Unknown => 1,
-    },
-    0x101f => { #11
-        Name => 'ExternalFlashAE1',
-        Writable => 'int32u',
-        Unknown => 1,
-    },
-    0x1020 => { #11
-        Name => 'ExternalFlashAE2',
-        Writable => 'int32u',
-        Unknown => 1,
-    },
-    0x1021 => { #11
-        Name => 'InternalFlashAE1',
-        Writable => 'int32u',
-        Unknown => 1,
-    },
-    0x1022 => { #11
-        Name => 'InternalFlashAE2',
-        Writable => 'int32u',
-        Unknown => 1,
-    },
-    0x1023 => { #6
-        Name => 'FlashExposureComp',
-        Writable => 'rational64s',
-    },
-    0x1024 => { #11
-        Name => 'InternalFlashTable',
-        Writable => 'int16u',
-    },
-    0x1025 => { #11
-        Name => 'ExternalFlashGValue',
-        Writable => 'rational64s',
-    },
+    0x101c => { Name => 'ExternalFlashAE2_0',   Writable => 'int32u', Unknown => 1 }, #11
+    0x101d => { Name => 'InternalFlashAE1_0',   Writable => 'int32u', Unknown => 1 }, #11
+    0x101e => { Name => 'InternalFlashAE2_0',   Writable => 'int32u', Unknown => 1 }, #11
+    0x101f => { Name => 'ExternalFlashAE1',     Writable => 'int32u', Unknown => 1 }, #11
+    0x1020 => { Name => 'ExternalFlashAE2',     Writable => 'int32u', Unknown => 1 }, #11
+    0x1021 => { Name => 'InternalFlashAE1',     Writable => 'int32u', Unknown => 1 }, #11
+    0x1022 => { Name => 'InternalFlashAE2',     Writable => 'int32u', Unknown => 1 }, #11
+    0x1023 => { Name => 'FlashExposureComp',    Writable => 'rational64s' }, #6
+    0x1024 => { Name => 'InternalFlashTable',   Writable => 'int16u' }, #11
+    0x1025 => { Name => 'ExternalFlashGValue',  Writable => 'rational64s' }, #11
     0x1026 => { #6
         Name => 'ExternalFlashBounce',
@@ -663,12 +1051,6 @@
         },
     },
-    0x1027 => { #6
-        Name => 'ExternalFlashZoom',
-        Writable => 'int16u',
-    },
-    0x1028 => { #6
-        Name => 'ExternalFlashMode',
-        Writable => 'int16u',
-    },
+    0x1027 => { Name => 'ExternalFlashZoom',    Writable => 'int16u' }, #6
+    0x1028 => { Name => 'ExternalFlashMode',    Writable => 'int16u' }, #6
     0x1029 => { #3
         Name => 'Contrast',
@@ -680,34 +1062,11 @@
         },
     },
-    0x102a => { #3
-        Name => 'SharpnessFactor',
-        Writable => 'int16u',
-    },
-    0x102b => { #3
-        Name => 'ColorControl',
-        Writable => 'int16u',
-        Count => 6,
-    },
-    0x102c => { #3
-        Name => 'ValidBits',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x102d => { #3
-        Name => 'CoringFilter',
-        Writable => 'int16u',
-    },
-    0x102e => { #PH
-        Name => 'OlympusImageWidth',
-        Writable => 'int32u',
-    },
-    0x102f => { #PH
-        Name => 'OlympusImageHeight',
-        Writable => 'int32u',
-    },
-    0x1030 => { #11
-        Name => 'SceneDetect',
-        Writable => 'int16u',
-    },
+    0x102a => { Name => 'SharpnessFactor',      Writable => 'int16u' }, #3
+    0x102b => { Name => 'ColorControl',         Writable => 'int16u', Count => 6 }, #3
+    0x102c => { Name => 'ValidBits',            Writable => 'int16u', Count => 2 }, #3
+    0x102d => { Name => 'CoringFilter',         Writable => 'int16u' }, #3
+    0x102e => { Name => 'OlympusImageWidth',    Writable => 'int32u' }, #PH
+    0x102f => { Name => 'OlympusImageHeight',   Writable => 'int32u' }, #PH
+    0x1030 => { Name => 'SceneDetect',          Writable => 'int16u' }, #11
     0x1031 => { #11
         Name => 'SceneArea',
@@ -724,11 +1083,9 @@
         Unknown => 1, # (but what does it mean?)
     },
-    0x1034 => { #3
-        Name => 'CompressionRatio',
-        Writable => 'rational64u',
-    },
+    0x1034 => { Name => 'CompressionRatio',    Writable => 'rational64u' }, #3
     0x1035 => { #6
         Name => 'PreviewImageValid',
         Writable => 'int32u',
+        DelValue => 0,
         PrintConv => { 0 => 'No', 1 => 'Yes' },
     },
@@ -739,4 +1096,5 @@
         DataTag => 'PreviewImage',
         Writable => 'int32u',
+        WriteGroup => 'MakerNotes',
         Protected => 2,
     },
@@ -747,10 +1105,8 @@
         DataTag => 'PreviewImage',
         Writable => 'int32u',
+        WriteGroup => 'MakerNotes',
         Protected => 2,
     },
-    0x1038 => { #11
-        Name => 'AFResult',
-        Writable => 'int16u',
-    },
+    0x1038 => { Name => 'AFResult',             Writable => 'int16u' }, #11
     0x1039 => { #6
         Name => 'CCDScanMode',
@@ -766,20 +1122,8 @@
         PrintConv => \%offOn,
     },
-    0x103b => { #6
-        Name => 'FocusStepInfinity',
-        Writable => 'int16u',
-    },
-    0x103c => { #6
-        Name => 'FocusStepNear',
-        Writable => 'int16u',
-    },
-    0x103d => { #11
-        Name => 'LightValueCenter',
-        Writable => 'rational64s',
-    },
-    0x103e => { #11
-        Name => 'LightValuePeriphery',
-        Writable => 'rational64s',
-    },
+    0x103b => { Name => 'FocusStepInfinity',    Writable => 'int16u' }, #6
+    0x103c => { Name => 'FocusStepNear',        Writable => 'int16u' }, #6
+    0x103d => { Name => 'LightValueCenter',     Writable => 'rational64s' }, #11
+    0x103e => { Name => 'LightValuePeriphery',  Writable => 'rational64s' }, #11
     0x103f => { #11
         Name => 'FieldCount',
@@ -1212,4 +1556,6 @@
         DataMember => 'CameraType',
         RawConv => '$self->{CameraType} = $val',
+        SeparateTable => 'CameraType',
+        PrintConv => \%olympusCameraTypes,
     },
 );
@@ -1231,4 +1577,6 @@
         Writable => 'string',
         Count => 6,
+        SeparateTable => 'CameraType',
+        PrintConv => \%olympusCameraTypes,
     },
     0x101 => { #PH
@@ -1262,15 +1610,15 @@
         Count => 6,
         Notes => q{
-            6 numbers: 0. Make, 1. Unknown, 2. Model, 3. Sub-model, 4-5. Unknown.  Only
-            the Make, Model and Sub-model are used to determine the lens model
+            6 numbers: 1. Make, 2. Unknown, 3. Model, 4. Sub-model, 5-6. Unknown.  Only
+            the Make, Model and Sub-model are used to identify the lens type
         },
         SeparateTable => 'LensType',
         # Have seen these values for the unknown numbers:
-        # 1: 0
-        # 4: 0, 2(Olympus lenses for which I have also seen 0 for this number)
-        # 5: 0, 16(new Lumix lenses)
-        ValueConv => 'my @a = split(" ",$val); "$a[0] $a[2] $a[3]"',
+        # 2: 0
+        # 5: 0, 2(Olympus lenses for which I have also seen 0 for this number)
+        # 6: 0, 16(new Lumix lenses)
+        ValueConv => 'my @a=split(" ",$val); sprintf("%x %.2x %.2x",@a[0,2,3])',
         # set unknown values to zero when writing
-        ValueConvInv => 'my @a=split(" ",$val); "$a[0] 0 $a[1] $a[2] 0 0"',
+        ValueConvInv => 'my @a=split(" ",$val); hex($a[0])." 0 ".hex($a[1])." ".hex($a[2])." 0 0"',
         PrintConv => \%olympusLensTypes,
     },
@@ -1290,8 +1638,5 @@
         PrintConvInv => 'pack("A31",$val)', # pad with spaces to 31 chars
     },
-    0x203 => { #17
-        Name => 'LensModel',
-        Writable => 'string',
-    },
+    0x203 => { Name => 'LensModel',         Writable => 'string' }, #17
     0x204 => { #6
         Name => 'LensFirmwareVersion',
@@ -1316,14 +1661,8 @@
         PrintConvInv => '$val',
     },
-    0x207 => { #PH
-        Name => 'MinFocalLength',
-        Writable => 'int16u',
-    },
-    0x208 => { #PH
-        Name => 'MaxFocalLength',
-        Writable => 'int16u',
-    },
+    0x207 => { Name => 'MinFocalLength',    Writable => 'int16u' }, #PH
+    0x208 => { Name => 'MaxFocalLength',    Writable => 'int16u' }, #PH
     0x20a => { #9
-        Name => 'MaxApertureAtCurrentFocal',
+        Name => 'MaxAperture', # (at current focal length)
         Writable => 'int16u',
         ValueConv => '$val ? sqrt(2)**($val/256) : 0',
@@ -1343,25 +1682,18 @@
         Count => 6,
         Notes => q{
-            6 numbers: 0. Make, 1. Unknown, 2. Model, 3. Sub-model, 4-5. Unknown.  Only
-            the Make and Model are used to determine the extender model
-        },
-        ValueConv => 'my @a = split(" ",$val); "$a[0] $a[2]"',
-        ValueConvInv => 'my @a=split(" ",$val); "$a[0] 0 $a[1] 0 0 0"',
-        PrintConv => {
-            '0 0'   => 'None',
-            '0 4'   => 'Olympus Zuiko Digital EC-14 1.4x Teleconverter',
-            '0 8'   => 'Olympus EX-25 Extension Tube',
-            '0 16'  => 'Olympus Zuiko Digital EC-20 2.0x Teleconverter', #7
-        },
-    },
-    0x302 => { #4
-        Name => 'ExtenderSerialNumber',
-        Writable => 'string',
-        Count => 32,
-    },
-    0x303 => { #9
-        Name => 'ExtenderModel',
-        Writable => 'string',
-    },
+            6 numbers: 1. Make, 2. Unknown, 3. Model, 4. Sub-model, 5-6. Unknown.  Only
+            the Make and Model are used to identify the extender
+        },
+        ValueConv => 'my @a=split(" ",$val); sprintf("%x %.2x",@a[0,2])',
+        ValueConvInv => 'my @a=split(" ",$val); hex($a[0])." 0 ".hex($a[1])." 0 0 0"',
+        PrintConv => {
+            '0 00' => 'None',
+            '0 04' => 'Olympus Zuiko Digital EC-14 1.4x Teleconverter',
+            '0 08' => 'Olympus EX-25 Extension Tube',
+            '0 10' => 'Olympus Zuiko Digital EC-20 2.0x Teleconverter', #7
+        },
+    },
+    0x302 => { Name => 'ExtenderSerialNumber',  Writable => 'string', Count => 32 }, #4
+    0x303 => { Name => 'ExtenderModel',         Writable => 'string' }, #9
     0x304 => { #6
         Name => 'ExtenderFirmwareVersion',
@@ -1370,4 +1702,9 @@
         PrintConvInv => '$val=sprintf("%.3f",$val);$val=~s/\.//;hex($val)',
     },
+    0x403 => { #http://dev.exiv2.org/issues/870
+        Name => 'ConversionLens',
+        Writable => 'string',
+        # (observed values: '','TCON','FCON','WCON')
+    },
     0x1000 => { #6
         Name => 'FlashType',
@@ -1377,4 +1714,5 @@
             2 => 'Simple E-System',
             3 => 'E-System',
+            4 => 'E-System (body powered)', #forum9740
         },
     },
@@ -1382,4 +1720,5 @@
         Name => 'FlashModel',
         Writable => 'int16u',
+        PrintConvColumns => 2,
         PrintConv => {
             0 => 'None',
@@ -1391,5 +1730,8 @@
             6 => 'FL-50R', #11 (or Metz mecablitz digital)
             7 => 'FL-36R', #11
-            # have seen value of 9 - PH
+            9 => 'FL-14', #11
+            11 => 'FL-600R', #11
+            13 => 'FL-LM3', #forum9740
+            15 => 'FL-900R', #7
         },
     },
@@ -1400,9 +1742,5 @@
         PrintConvInv => '$val=sprintf("%.3f",$val);$val=~s/\.//;hex($val)',
     },
-    0x1003 => { #4
-        Name => 'FlashSerialNumber',
-        Writable => 'string',
-        Count => 32,
-    },
+    0x1003 => { Name => 'FlashSerialNumber', Writable => 'string', Count => 32 }, #4
 );
 
@@ -1430,4 +1768,5 @@
         DataTag => 'PreviewImage',
         Writable => 'int32u',
+        WriteGroup => 'MakerNotes',
         Protected => 2,
     },
@@ -1437,4 +1776,5 @@
         DataTag => 'PreviewImage',
         Writable => 'int32u',
+        WriteGroup => 'MakerNotes',
         Protected => 2,
     },
@@ -1467,7 +1807,8 @@
         },
     },
-    0x203 => { #11 (some E-models only)
-        Name => 'ExposureShift',
-        Writable => 'rational64s',
+    0x203 => { Name => 'ExposureShift', Writable => 'rational64s' }, #11 (some models only)
+    0x204 => { #11 (XZ-1)
+        Name => 'NDFilter',
+        PrintConv => \%offOn,
     },
     0x300 => { #6
@@ -1490,14 +1831,19 @@
             2 => 'Continuous AF',
             3 => 'Multi AF',
-            5 => 'Face detect', #11
+            4 => 'Face detect', #11
             10 => 'MF',
-        }, { BITMASK => { #11
-            0 => 'S-AF',
-            2 => 'C-AF',
-            4 => 'MF',
-            5 => 'Face detect',
-            6 => 'Imager AF',
-            8 => 'AF sensor',
-        }}],
+        }, {
+            0 => '(none)',
+            BITMASK => { #11
+                0 => 'S-AF',
+                2 => 'C-AF',
+                4 => 'MF',
+                5 => 'Face detect',
+                6 => 'Imager AF',
+                7 => 'Live View Magnification Frame',
+                8 => 'AF sensor',
+                9 => 'Starry Sky AF', #24
+            },
+        }],
     },
     0x302 => { #6
@@ -1526,5 +1872,5 @@
         Name => 'AFAreas',
         Notes => 'coordinates range from 0 to 255',
-        Format => 'int32u',
+        Writable => 'int32u',
         Count => 64,
         PrintConv => 'Image::ExifTool::Olympus::PrintAFAreas($val)',
@@ -1533,17 +1879,32 @@
         Name => 'AFPointSelected',
         Notes => 'coordinates expressed as a percent',
-        Format => 'rational64s',
+        Writable => 'rational64s',
         Count => 5,
         ValueConv => '$val =~ s/\S* //; $val', # ignore first undefined value
         ValueConvInv => '"undef $val"',
         PrintConv => q{
-            return $val if $val =~ /undef/;
+            return 'n/a' if $val =~ /undef/;
             sprintf("(%d%%,%d%%) (%d%%,%d%%)", map {$_ * 100} split(" ",$val));
-        }
+        },
+        PrintConvInv => q{
+            return 'undef undef undef undef' if $val eq 'n/a';
+            my @nums = $val =~ /\d+(?:\.\d+)?/g;
+            return undef unless @nums == 4;
+            join ' ', map {$_ / 100} @nums;
+        },
+    },
+    0x306 => { #11
+        Name => 'AFFineTune',
+        Writable => 'int8u',
+        PrintConv => { 0 => 'Off', 1 => 'On' },
     },
     0x307 => { #15
         Name => 'AFFineTuneAdj',
-        Format => 'int16s',
+        Writable => 'int16s',
         Count => 3, # not sure what the 3 values mean
+    },
+    0x308 => { #forum11578
+        Name => 'FocusBracketStepSize',
+        Writable => 'int8u',
     },
     0x400 => { #6
@@ -1562,13 +1923,11 @@
         },
     },
-    0x401 => { #6
-        Name => 'FlashExposureComp',
-        Writable => 'rational64s',
-    },
-    # 0x402 - FlashMode? bit0=TTL, bit2=SuperFP (ref 11)
+    0x401 => { Name => 'FlashExposureComp', Writable => 'rational64s' }, #6
+    # 0x402 - FlashMode? bit0=TTL, bit1=auto, bit2=SuperFP (ref 11)
     0x403 => { #11
         Name => 'FlashRemoteControl',
         Writable => 'int16u',
         PrintHex => 1,
+        PrintConvColumns => 2,
         PrintConv => {
             0 => 'Off',
@@ -1590,5 +1949,6 @@
         Name => 'FlashControlMode',
         Writable => 'int16u',
-        Count => 3,
+        Count => -1,
+        Notes => '3 or 4 values',
         PrintConv => [{
             0 => 'Off',
@@ -1601,14 +1961,22 @@
         Name => 'FlashIntensity',
         Writable => 'rational64s',
-        Count => 3,
-        PrintConv => '$val eq "undef undef undef" ? "n/a" : $val',
-        PrintConvInv => '$val eq "n/a" ? "undef undef undef" : $val',
+        Count => -1,
+        Notes => '3 or 4 values',
+        PrintConv => {
+            OTHER => sub { shift },
+            'undef undef undef' => 'n/a',
+            'undef undef undef undef' => 'n/a (x4)',
+        },
     },
     0x406 => { #11
         Name => 'ManualFlashStrength',
         Writable => 'rational64s',
-        Count => 3,
-        PrintConv => '$val eq "undef undef undef" ? "n/a" : $val',
-        PrintConvInv => '$val eq "n/a" ? "undef undef undef" : $val',
+        Count => -1,
+        Notes => '3 or 4 values',
+        PrintConv => {
+            OTHER => sub { shift },
+            'undef undef undef' => 'n/a',
+            'undef undef undef undef' => 'n/a (x4)',
+        },
     },
     0x500 => { #6
@@ -1617,4 +1985,5 @@
         PrintConv => {
             0 => 'Auto',
+            1 => 'Auto (Keep Warm Color Off)', #IB
             16 => '7500K (Fine Weather with Shade)',
             17 => '6000K (Cloudy)',
@@ -1622,15 +1991,20 @@
             20 => '3000K (Tungsten light)',
             21 => '3600K (Tungsten light-like)',
+            22 => 'Auto Setup', #IB
+            23 => '5500K (Flash)', #IB
             33 => '6600K (Daylight fluorescent)',
             34 => '4500K (Neutral white fluorescent)',
             35 => '4000K (Cool white fluorescent)',
+            36 => 'White Fluorescent', #IB
             48 => '3600K (Tungsten light-like)',
-            256 => 'Custom WB 1',
-            257 => 'Custom WB 2',
-            258 => 'Custom WB 3',
-            259 => 'Custom WB 4',
-            512 => 'Custom WB 5400K',
-            513 => 'Custom WB 2900K',
-            514 => 'Custom WB 8000K',
+            67 => 'Underwater', #IB
+            256 => 'One Touch WB 1', #IB
+            257 => 'One Touch WB 2', #IB
+            258 => 'One Touch WB 3', #IB
+            259 => 'One Touch WB 4', #IB
+            512 => 'Custom WB 1', #IB
+            513 => 'Custom WB 2', #IB
+            514 => 'Custom WB 3', #IB
+            515 => 'Custom WB 4', #IB
         },
     },
@@ -1699,4 +2073,5 @@
         Name => 'SceneMode',
         Writable => 'int16u',
+        PrintConvColumns => 2,
         PrintConv => {
             0 => 'Standard',
@@ -1746,13 +2121,20 @@
             49 => 'Underwater Snapshot', #11
             50 => 'Shooting Guide', #11
-            51 => 'Face Portrait', #PH (NC)
-            52 => 'Smile Shot', #PH (NC)
-            53 => 'Quick Shutter', #PH (NC)
-            54 => 'Slow Shutter', #PH (NC)
-            55 => 'Bird Watching', #PH (NC)
-            56 => 'Multiple Exposure', #PH (NC)
-            57 => 'e-Portrait', #PH (NC)
-            58 => 'Beauty Fix', #PH (NC)
-            59 => 'Soft Background', #PH (NC)
+            54 => 'Face Portrait', #11
+            57 => 'Bulb', #11
+            59 => 'Smile Shot', #11
+            60 => 'Quick Shutter', #11
+            63 => 'Slow Shutter', #11
+            64 => 'Bird Watching', #11
+            65 => 'Multiple Exposure', #11
+            66 => 'e-Portrait', #11
+            67 => 'Soft Background Shot', #11
+            142 => 'Hand-held Starlight', #PH (SH-21)
+            154 => 'HDR', #PH (XZ-2)
+            197 => 'Panning', #forum11631 (EM5iii)
+            203 => 'Light Trails', #forum11631 (EM5iii)
+            204 => 'Backlight HDR', #forum11631 (EM5iii)
+            205 => 'Silent', #forum11631 (EM5iii)
+            206 => 'Multi Focus Shot', #forum11631 (EM5iii)
         },
     },
@@ -1761,4 +2143,5 @@
         Writable => 'int16u',
         PrintConv => {
+            0 => '(none)',
             BITMASK => {
                 0 => 'Noise Reduction',
@@ -1779,8 +2162,5 @@
         PrintConv => \%offOn,
     },
-    0x50d => { #PH/4
-        Name => 'CompressionFactor',
-        Writable => 'rational64u',
-    },
+    0x50d => { Name => 'CompressionFactor', Writable => 'rational64u' }, #PH/4
     0x50f => { #6
         Name => 'Gradation',
@@ -1790,4 +2170,5 @@
         Relist => [ [0..2], 3 ], # join values 0-2 for PrintConv
         PrintConv => [{
+           '0 0 0' => 'n/a', #PH (?)
            '-1 -1 1' => 'Low Key',
             '0 -1 1' => 'Normal',
@@ -1809,4 +2190,12 @@
             4 => 'Portrait',
             5 => 'i-Enhance', #11
+            6 => 'e-Portrait', #23
+            7 => 'Color Creator', #23
+            9 => 'Color Profile 1', #23
+            10 => 'Color Profile 2', #23
+            11 => 'Color Profile 3', #23
+            12 => 'Monochrome Profile 1', #23
+            13 => 'Monochrome Profile 2', #23
+            14 => 'Monochrome Profile 3', #23
             256 => 'Monotone',
             512 => 'Sepia',
@@ -1846,4 +2235,5 @@
         Name => 'PictureModeBWFilter',
         Writable => 'int16s',
+        PrintConvColumns => 2,
         PrintConv => {
             0 => 'n/a',
@@ -1858,4 +2248,5 @@
         Name => 'PictureModeTone',
         Writable => 'int16s',
+        PrintConvColumns => 2,
         PrintConv => {
             0 => 'n/a',
@@ -1872,4 +2263,5 @@
         Count => 3,
         PrintConv => {
+           '0 0 0' => 'n/a', #PH (?)
            '-2 -2 1' => 'Off',
            '-1 -2 1' => 'Low',
@@ -1882,4 +2274,5 @@
         Writable => 'int16u',
         Count => 4,
+        PrintConvColumns => 2,
         PrintConv => [ \%filters ],
     },
@@ -1887,15 +2280,183 @@
         Name => 'MagicFilter',
         Writable => 'int16u',
-        Count => 4, # (2nd number is 0 or 1280, 3rd/4th are 0)
+        Count => 4, # (2nd number is 0, 1280 or 1792, 3rd/4th are 0)
+        # (1792 observed for E-5 Gentle Sepia and XZ-1 Dramatic Tone)
+        PrintConvColumns => 2,
         PrintConv => [ \%filters ],
     },
-    0x600 => { #PH/4
+    0x52d => { #11
+        Name => 'PictureModeEffect',
+        Writable => 'int16s',
+        Count => 3,
+        PrintConv => {
+           '0 0 0' => 'n/a', #PH (?)
+           '-1 -1 1' => 'Low',
+           '0 -1 1' => 'Standard',
+           '1 -1 1' => 'High',
+        },
+    },
+    0x52e => { #11/PH
+        Name => 'ToneLevel',
+        PrintConv => [
+            \%toneLevelType,
+            undef, # (highlights value)
+            undef, # (highlights min)
+            undef, # (highlights max)
+            \%toneLevelType,
+            undef, # (shadows value)
+            undef, # (shadows min)
+            undef, # (shadows max)
+            \%toneLevelType,
+            undef, # (midtones value)
+            undef, # (midtones min)
+            undef, # (midtones max)
+            \%toneLevelType,
+            undef,
+            undef,
+            undef,
+            \%toneLevelType,
+            undef,
+            undef,
+            undef,
+            \%toneLevelType,
+            undef,
+            undef,
+            undef,
+            \%toneLevelType,
+            undef,
+            undef,
+            undef,
+        ]
+    },
+    0x52f => { #PH
+        Name => 'ArtFilterEffect',
+        Writable => 'int16u',
+        Count => 20,
+        PrintHex => 1,
+        PrintConvColumns => 2,
+        PrintConv => [
+            \%filters,
+            undef,
+            undef,
+            '"Partial Color $val"', #23
+            {   # there are 5 available art filter effects for the E-PL3...
+                0x0000 => 'No Effect',
+                0x8010 => 'Star Light',
+                0x8020 => 'Pin Hole',
+                0x8030 => 'Frame',
+                0x8040 => 'Soft Focus',
+                0x8050 => 'White Edge',
+                0x8060 => 'B&W', # (NC - E-PL2 with "Grainy Film" filter)
+                0x8080 => 'Blur Top and Bottom', #23
+                0x8081 => 'Blur Left and Right', #23
+                # (E-PL2 also has "Pict. Tone" effect)
+            },
+            undef,
+            { #23
+                0 => 'No Color Filter',
+                1 => 'Yellow Color Filter',
+                2 => 'Orange Color Filter',
+                3 => 'Red Color Filter',
+                4 => 'Green Color Filter',
+            },
+        ],
+    },
+    0x532 => { #23
+        Name => 'ColorCreatorEffect',
+        Writable => 'int16s',
+        Count => 6,
+        PrintConv => [
+            '"Color $val"',
+            undef, # (Color min)
+            undef, # (Color max)
+            '"Strength $val"',
+            undef, # (Strength min)
+            undef, # (Strength max)
+        ],
+    },
+    0x537 => { #23
+        Name => 'MonochromeProfileSettings',
+        Writable => 'int16s',
+        Count => 6,
+        PrintConv => [
+            {
+                0 => 'No Filter',
+                1 => 'Yellow Filter',
+                2 => 'Orange Filter',
+                3 => 'Red Filter',
+                4 => 'Magenta Filter',
+                5 => 'Blue Filter',
+                6 => 'Cyan Filter',
+                7 => 'Green Filter',
+                8 => 'Yellow-green Filter',
+            },
+            undef, # (Filter number min)
+            undef, # (Filter number max)
+            '"Strength $val"',
+            undef, # (Strength min)
+            undef, # (Strength max)
+        ],
+    },
+    0x538 => { #23
+        Name => 'FilmGrainEffect',
+        Writable => 'int16s',
+        PrintConv => {
+            0 => 'Off',
+            1 => 'Low',
+            2 => 'Medium',
+            3 => 'High',
+        },
+    },
+    0x539 => { #23
+        Name => 'ColorProfileSettings',
+        Writable => 'int16s',
+        Count => 14,
+        PrintConv => [
+            '"Min $val"',
+            '"Max $val"',
+            '"Yellow $val"',
+            '"Orange $val"',
+            '"Orange-red $val"',
+            '"Red $val"',
+            '"Magenta $val"',
+            '"Violet $val"',
+            '"Blue $val"',
+            '"Blue-cyan $val"',
+            '"Cyan $val"',
+            '"Green-cyan $val"',
+            '"Green $val"',
+            '"Yellow-green $val"',
+        ],
+    },
+    0x53a => { #23
+        Name => 'MonochromeVignetting',
+        Writable => 'int16s',
+        Notes => '-5 to +5: positive is white vignetting, negative is black vignetting',
+    },
+    0x53b => { #23
+        Name => 'MonochromeColor',
+        Writable => 'int16s',
+        PrintConv => {
+            0 => '(none)',
+            1 => 'Normal',
+            2 => 'Sepia',
+            3 => 'Blue',
+            4 => 'Purple',
+            5 => 'Green',
+        },
+    },
+    0x600 => { #PH/4/22
         Name => 'DriveMode',
         Writable => 'int16u',
         Count => -1,
-        Notes => '2 or 3 numbers: 1. Mode, 2. Shot number, 3. Mode bits',
+        Notes => '2, 3 or 5 numbers: 1. Mode, 2. Shot number, 3. Mode bits, 5. Shutter mode',
         PrintConv => q{
-            my ($a,$b,$c) = split ' ',$val;
-            return 'Single Shot' unless $a;
+            my ($a,$b,$c,$d,$e) = split ' ',$val;
+            if ($e) {
+                $e = '; ' . ({ 2 => 'Anti-shock 0', 4 => 'Electronic shutter' }->{$e} || "Unknown ($e)");
+            } else {
+                $e = '';
+            }
+            return "Single Shot$e" unless $a;
             if ($a == 5 and defined $c) {
                 $a = DecodeBits($c, { #6
